import { CLI } from "../../../index";
/**
 * TO START IN CONSOLE: "./bin/actionhero start cluster"
 * ** Production-ready actionhero cluster **
 * - be sure to enable redis so that workers can share state
 * - workers which die will be restarted
 * - maser/manager specific logging
 * - pidfile for master
 * - USR2 restarts (graceful reload of workers while handling requests)
 *   -- Note, socket/websocket clients will be disconnected, but there will always be a worker to handle them
 *   -- HTTP/HTTPS/TCP clients will be allowed to finish the action they are working on before the server goes down
 * - TTOU and TTIN signals to subtract/add workers
 * - TCP, HTTP(S), and Web-socket clients will all be shared across the cluster
 * - Can be run as a daemon or in-console
 *   -- Simple Daemon: "actionhero start cluster --daemon"
 * * Setting process titles does not work on windows or OSX
 * This tool was heavily inspired by Ruby Unicorns [[ http://unicorn.bogomips.org/ ]]
 */
export declare class StartCluster extends CLI {
    constructor();
    run({ params }: {
        params: any;
    }): Promise<boolean>;
}
