import { Process } from "./process";
import { ActionsApi } from "./../initializers/actions";
import { TaskApi } from "./../initializers/tasks";
import { ConnectionsApi } from "./../initializers/connections";
import { ServersApi } from "./../initializers/servers";
import { ChatRoomApi } from "./../initializers/chatRoom";
import { ExceptionHandlerAPI } from "./../initializers/exceptions";
import { ParamsApi } from "./../initializers/params";
import { ResqueApi } from "./../initializers/resque";
import { RedisApi } from "./../initializers/redis";
import { StaticFileApi } from "./../initializers/staticFile";
import { DocumentationApi } from "./../initializers/documentation";
import { RoutesApi } from "./../initializers/routes";
import { SpecHelperApi } from "./../initializers/specHelper";
export declare class Api {
    running: boolean;
    bootTime: number;
    process?: Process;
    commands: {
        initialize?: Function;
        start?: Function;
        stop?: Function;
        restart?: Function;
    };
    connections: ConnectionsApi;
    actions: ActionsApi;
    tasks: TaskApi;
    servers: ServersApi;
    chatRoom: ChatRoomApi;
    params: ParamsApi;
    documentation: DocumentationApi;
    staticFile: StaticFileApi;
    redis: RedisApi;
    resque: ResqueApi;
    routes: RoutesApi;
    exceptionHandlers: ExceptionHandlerAPI;
    specHelper: SpecHelperApi;
    [key: string]: any;
    constructor();
}
