import { Api } from "./api";
import { Initializers } from "./initializers";
export declare class Process {
    running: boolean;
    initialized: boolean;
    shuttingDown: boolean;
    bootTime: number;
    initializers: Initializers;
    startCount: number;
    loadInitializers: Array<Function>;
    startInitializers: Array<Function>;
    stopInitializers: Array<Function>;
    _startingParams: {
        [key: string]: any;
    };
    constructor();
    initialize(params?: object): Promise<void | Api>;
    start(params?: {}): Promise<void | Api>;
    stop(): Promise<void>;
    restart(): Promise<Api>;
    fatalError(errors: any, type: any): Promise<void>;
    flattenOrderedInitialzer(collection: any): any[];
}
