"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const optimist_1 = require("optimist");
const cluster = require("cluster");
const config_1 = require("./../../modules/config");
const utils_1 = require("./../../modules/utils");
/**
 * I build this server's ID from the external IP address of this server and pid.
 */
function determineId() {
    let id = "";
    if (optimist_1.argv.title) {
        id = optimist_1.argv.title;
    }
    else if (process.env.ACTIONHERO_TITLE) {
        id = process.env.ACTIONHERO_TITLE;
    }
    else if (process.env.JEST_WORKER_ID) {
        id = `test-server-${process.env.JEST_WORKER_ID || 0}`;
    }
    else if (!config_1.config || !config_1.config.general.id) {
        let externalIP = utils_1.utils.getExternalIPAddress();
        if (!externalIP) {
            const message = " * Error fetching this hosts external IP address; setting id base to 'actionhero'";
            console.log(message);
            externalIP = "actionhero";
        }
        id = externalIP;
        if (cluster.isWorker) {
            id += ":" + process.pid;
        }
    }
    else {
        id = config_1.config.general.id;
    }
    return id;
}
exports.id = determineId();
