"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const fs = require("fs");
const cluster = require("cluster");
const log_1 = require("../../modules/log");
const config_1 = require("./../../modules/config");
const id_1 = require("./id");
function sanitizeId() {
    let pidfile = String(id_1.id).trim();
    pidfile = pidfile.replace(new RegExp(":", "g"), "-");
    pidfile = pidfile.replace(new RegExp(" ", "g"), "_");
    return pidfile;
}
exports.pid = process.pid;
const path = config_1.config.general.paths.pid[0]; // it would be silly to have more than one pi
let title = sanitizeId();
if (cluster.isMaster) {
    title = "actionhero-" + title;
}
try {
    fs.mkdirSync(path);
}
catch (e) { }
function writePidFile() {
    log_1.log(`pid: ${process.pid}`, "notice");
    fs.writeFileSync(path + "/" + title, exports.pid.toString(), "ascii");
}
exports.writePidFile = writePidFile;
function clearPidFile() {
    try {
        fs.unlinkSync(path + "/" + title);
    }
    catch (error) {
        log_1.log("Unable to remove pidfile", "error", error);
    }
}
exports.clearPidFile = clearPidFile;
