"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const index_1 = require("../index");
const config_1 = require("./../modules/config");
const glob = require("glob");
/**
 * restarts the server when config files change
 */
class Params extends index_1.Initializer {
    constructor() {
        super();
        this.name = "config";
        this.loadPriority = 100;
    }
    async initialize() {
        config_1.configPaths.map(configPath => {
            const files = glob.sync(`${configPath}/**/*`);
            files.map(file => {
                index_1.watchFileAndAct(file, async () => {
                    index_1.log(`*** Rebooting due to config change (${file}) ***`, "info");
                    await index_1.api.commands.restart();
                });
            });
        });
    }
}
exports.Params = Params;
