import { Queue, Scheduler, MultiWorker } from "node-resque";
import { Initializer } from "../index";
export interface ResqueApi {
    connectionDetails: {
        [key: string]: any;
    };
    queue?: Queue;
    scheduler?: Scheduler;
    multiWorker?: MultiWorker;
    startQueue?: Function;
    stopQueue?: Function;
    startScheduler?: Function;
    stopScheduler?: Function;
    startMultiWorker?: Function;
    stopMultiWorker?: Function;
    workerLogging?: any;
    schedulerLogging?: any;
}
/**
 * The node-resque workers and scheduler which process tasks.
 * see https://github.com/actionhero/node-resque
 */
export declare class Resque extends Initializer {
    constructor();
    initialize(config: any): Promise<void>;
    start(config: any): Promise<void>;
    stop(config: any): Promise<void>;
}
